Last Comment Bug 247884 - Upgrading doesn't remove / uninstall the old entry from Add Remove Programs - Windows
: Upgrading doesn't remove / uninstall the old entry from Add Remove Programs -...
Status: VERIFIED FIXED
[asaP1]
: fixed-aviary1.0.3
Product: Firefox
Classification: Client Software
Component: Installer (show other bugs)
: Trunk
: x86 All
: -- critical with 78 votes (vote)
: ---
Assigned To: Brian Ryner (not reading)
:
:
Mentors:
: 247708 250495 254335 254432 254854 261365 261770 262470 266354 266508 267658 267659 267689 269808 270018 271247 272784 272871 280841 283577 284162 285413 287553 287864 287887 287968 288116 288125 288870 289762 289939 290119 290654 290718 292057 292161 305468 (view as bug list)
Depends on:
Blocks: 284754
  Show dependency treegraph
 
Reported: 2004-06-20 22:35 PDT by Hari Kumar G
Modified: 2012-09-08 14:08 PDT (History)
85 users (show)
asa: blocking‑aviary1.0-
chase: blocking‑aviary1.5+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
patch (12.70 KB, patch)
2004-10-03 18:49 PDT, Ben Goodger (use ben at mozilla dot org for email)
no flags Details | Diff | Splinter Review
Current visual representation (1.0) (17.24 KB, image/png)
2004-12-09 11:24 PST, Brad Fults
no flags Details
Proposed Dialog (10.76 KB, image/png)
2004-12-09 12:15 PST, Brad Fults
no flags Details
fix (firefox and thunderbird) (1.79 KB, patch)
2005-03-25 16:11 PST, Brian Ryner (not reading)
bugs: review+
dbaron: approval‑aviary1.0.3+
Details | Diff | Splinter Review
Show Updates (28.21 KB, image/gif)
2005-04-02 15:47 PST, Erlendur S Thorsteinsson
no flags Details
Still a problem (68.06 KB, image/png)
2007-03-11 10:38 PDT, u49640
no flags Details

Description Hari Kumar G 2004-06-20 22:35:52 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.7) Gecko/20040614 Firefox/0.9
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.7) Gecko/20040614 Firefox/0.9

If the user chooses to overinstall 0.9 on 0.8 and installs it to the same
directory where he installed 0.8, the entry regarding uninstall info for 0.8 is
not removed from Add/remove programs.  After installation both the entries will
be available in the Add/remove programs panel.

Reproducible: Always
Steps to Reproduce:
1.
2.
3.



Expected Results:  
The installer should check for older versions and ask the user whether to update
or keep them.  if update is chosen the necessary updations should be done.  If
he chooses to keep them, should do likewise.
Comment 1 Tim Meader 2004-06-20 22:42:12 PDT
Most installers on Windows handle this differently from the suggestion. Instead
of prompting you, they silently update the Add/Remove entry to reflect the new
product version. I think that's the direction that a fix for this should really
take.
Comment 2 Hari Kumar G 2004-06-20 22:46:44 PDT
(In reply to comment #1)
> Most installers on Windows handle this differently from the suggestion. Instead
> of prompting you, they silently update the Add/Remove entry to reflect the new
> product version. I think that's the direction that a fix for this should really
> take.

In the case the user chooses to do a custom install and chooses a different
directory what would be result?

I feel the above option should do for the standard install and in case of custom
there should be checks and confirmations from the user.
Comment 3 DunxD 2004-07-01 10:26:39 PDT
This still happens for 0.9.1 - it leaves an entry in the Add/Remove programmes
dialogue for 0.9.  The user could well think that two different versions of
Firefox are installed, but uninstalling 0.9 uninstalls Firefox completely.

If the user installs Firefox into the same directory as an existing
installation, shouldn't it overwrite the add/remove entry?  Files will certainly
be overwritten so by installing a new version the older version is effectively
removed.  In these cases the update should overwrite the previous Add/Remove entry.

If the user installs into a different directory, there is probably a good reason
for this in most cases - i.e. run different version's side by side.  If the user
did this, the Add/Remove entries WOULD point to different files, so having both
would be correct, and wouldn't lead to any un-expected loss of data.

If it is possible to detect these two cases, this would seem the best way to
proceed.
Comment 4 Brant Gurganus 2004-07-09 07:22:56 PDT
Confirmed.
Comment 5 Ted Mielczarek [:ted.mielczarek] 2004-08-05 09:16:02 PDT
*** Bug 254432 has been marked as a duplicate of this bug. ***
Comment 6 Michael Lefevre 2004-08-15 16:06:28 PDT
*** Bug 254854 has been marked as a duplicate of this bug. ***
Comment 7 Mike Harris 2004-08-16 07:05:44 PDT
I also confirmed this bug using the following versions of FireFox:  0.9.1,
0.9.2, and 0.9.3.  I have confirmed this on Windows 2000 Pro and Windows XP Pro,
with the exact same effects.
Comment 8 Worcester12345 2004-08-16 09:41:02 PDT
I'm pretty sure this does this with older versions (.7) as well. Also Thunderbird. 

I know VNC will just update the Add/Remove area when you update the program.
Pretty sure Acrobat Reader does not for two examples of how other programs do it.
Comment 9 Jo Hermans 2004-08-24 04:30:50 PDT
*** Bug 254335 has been marked as a duplicate of this bug. ***
Comment 10 Jo Hermans 2004-08-24 04:31:22 PDT
*** Bug 250495 has been marked as a duplicate of this bug. ***
Comment 11 Worcester12345 2004-08-25 14:57:21 PDT
(In reply to comment #8)
> I'm pretty sure this does this with older versions (.7) as well. Also
Thunderbird. 
> 
> I know VNC will just update the Add/Remove area when you update the program.
> Pretty sure Acrobat Reader does not for two examples of how other programs do it.

Verified it today. .7, .8, and various versions of .9 are all in Add/Remove
Programs control panel even though a nightly (0.9.1+ maybe?) is the actual
working version.
Comment 12 Asa Dotzler [:asa] 2004-09-14 19:29:53 PDT
There are two options here, uninstall the old version or just remove the listing
if the new install is on top of the old one. I recommend uninstall. That solves
this and other problems.

We should get this for 1.0.
Comment 13 Patrick Schmitz 2004-09-15 02:17:30 PDT
(In reply to comment #12)
> There are two options here, uninstall the old version or just remove the listing
> if the new install is on top of the old one. I recommend uninstall. That solves
> this and other problems.

Uninstall is indeed the prefered method. It prevents potential conflicts between
files of different versions. But all extensions available in the programs
directory will also be removed. Don't know if that is desired.

> We should get this for 1.0.

Totally agree with you.
Comment 14 alex 2004-09-18 05:34:23 PDT
I think that this bug puts lots of new users off updating. If an unistaller was
made for windows it would allow for an easy fix of bug: 234680. If the installer
gave the option  to unistall old versions then exited: running the unistaller
with a switch to re-run the install program. 
Comment 15 José Jeria 2004-09-24 03:47:12 PDT
*** Bug 261365 has been marked as a duplicate of this bug. ***
Comment 16 Olaf van der Spek 2004-09-24 03:54:09 PDT
(In reply to comment #12)
> There are two options here, uninstall the old version or just remove the 
listing
> if the new install is on top of the old one. I recommend uninstall. That 
solves
> this and other problems.
> We should get this for 1.0.

Another option would be to remove the version number from the uninstall 
registry key and add a hash of the install dir.
If the install dir is different -> new entry.
If it's the same -> overwrite.
Comment 17 José Jeria 2004-09-28 02:27:32 PDT
*** Bug 261770 has been marked as a duplicate of this bug. ***
Comment 18 Bill Mason 2004-10-01 15:07:45 PDT
*** Bug 262470 has been marked as a duplicate of this bug. ***
Comment 19 Ben Goodger (use ben at mozilla dot org for email) 2004-10-03 18:49:33 PDT
Created attachment 160965 [details] [diff] [review]
patch

clean up uninstall entries for versions installed to the same location.
Comment 20 Worcester12345 2004-10-04 14:19:08 PDT
I don't think this is fixed completely yet.

I installed (using installer) and am currently running this version: Mozilla/5.0
(Windows; U; Windows NT 5.1; en-US; rv:1.7.3) Gecko/20041004 Firefox/0.10

and it still lists under the Add or Remove Programs control panel:

"Mozilla Firebird (0.7+.)"
    "To change this program or remove it from your computer, click Change/Remove."

Clicking "Change/Remove" produces an error.

Comment 21 Nitin (vfwlkr) 2004-10-04 17:52:46 PDT
@comment 20
The patch is applicable only if the install directory is same.. which is not the
case for firebird/firefox. If a user chooses to install 10 different versions in
different directories, upgrading will and should not remove previous versions.

Verified as working with:
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.3) Gecko/20041004
Firefox/0.10.1
Comment 22 HEAT84 2004-10-25 22:49:27 PDT
You could also do it like AOL does (or did). They have (or had) 1 ununstall
entry for all installed versions where you could select which version(s) you
wanted to uninstall. BTW I encountered this bug when upgrading from 0.9.1 to 1.0PR.
Comment 23 Pavel Penaz 2004-11-04 04:21:58 PST
It seems this bug is back with the release of Firefox 1.0 RC1 and RC2 builds. I
have both RC1 and RC2 uninstall entries in the Add/Remove dialog. Can anyone
confirm this?
Comment 24 Simon Paquet [:sipaq] 2004-11-04 04:33:49 PST
*** Bug 267659 has been marked as a duplicate of this bug. ***
Comment 25 Kipp Howard 2004-11-04 09:17:19 PST
I've just upgrade from 1.0PR to 1.0RC2 using Firefox's upgrade feature.  I think
I'm seeing something a little different than what others are seeing here.

After upgrading, the Win2K Server's "Add/Remove Programs" shows an entry for
"Mozilla Firefox (1.0PR)" and NO entry for "Mozilla Firefox (1.0RC2)".  If I
press the "Change/Remove" button, the uninstall continues and then asks if I'm
sure that I would like to remove "Mozilla Firefox (1.0PR)".

Others here say that they see an entry for the new Firefox.  I am not see that.
Comment 26 Simon Paquet [:sipaq] 2004-11-04 09:58:31 PST
*** Bug 267658 has been marked as a duplicate of this bug. ***
Comment 27 Simon Paquet [:sipaq] 2004-11-04 10:00:33 PST
*** Bug 267689 has been marked as a duplicate of this bug. ***
Comment 28 Alan Sanderson 2004-11-04 10:40:29 PST
From https://bugzilla.mozilla.org/show_bug.cgi?id=267689

Upon upgrading from Firebird RC 1 to Firebird RC 2 (installing in the same
directory), I noticed the following
entries still in my registry. 
HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla
Firefox (1.0RC1)
This one in particular has the effect that there are two uninstall entries in
add/remove, one for Firebird RC1 and on for Firebird RC2.
Futher entries left in the register by the installer that should probably not be
there are upgrade are;
HKEY_CURRENT_USER\Software\Mozilla\Mozilla Firefox 1.0RC1\bin
HKEY_CURRENT_USER\Software\Mozilla\Mozilla Firefox 1.0RC1\Extensions
HKEY_CURRENT_USER\Software\Mozilla\Mozilla Firefox 1.0RC1
HKEY_LOCAL_MACHINE\Software\Mozilla\Mozilla Firefox 1.0RC1\bin
HKEY_LOCAL_MACHINE\Software\Mozilla\Mozilla Firefox 1.0RC1\Extensions
HKEY_LOCAL_MACHINE\Software\Mozilla\Mozilla Firefox 1.0RC1
Comment 29 u49640 2004-11-04 11:15:47 PST
i've just checked my Add/Remove list and i see 1.0PR, 1.0RC1 and 1.0RC2

i've installed them in the same folder as the old one so this may not be fixed
completely.

i think it would be a great idea to not put the version info in this List and
just  write "Mozilla Firefox"
Comment 30 Thorsten Kaiser 2004-11-04 11:16:22 PST
I can confirm the problem reported in #25.

I have upgraded from PR to RC2 on two machines, one with WinNT4 SP6 and the
other with Win98 SE. Same problem on both machines.

The way how I upgraded was to follow the instructions given in
http://www.mozilla.org/projects/firefox/qa/softwareupdate.html

A check in the registry showed that I now have entries for both, PR and RC2.
So the upgrade messed up my registry entries for Firefox.

I think this definitely needs to be fixed by final 1.0. Installation and
upgrading needs to work without glitches in a major revision number. 

I have not tried uninstalling, so I don't know if it works fine regardless of
these entries.
Comment 31 Worcester12345 2004-11-04 16:29:53 PST
Based on all the above, shouldn't this be reopened?
Comment 32 Wil Li 2004-11-04 19:19:55 PST
I don't know if this might help but this might help: 
http://search.microsoft.com/search/results.aspx?qu=patching+and+upgrades&View=msdn&st=b&c=0&s=1&swc=0


and base on this:
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/msi/setup/patching_and_upgrades.asp
I think you'll only need to change the version numbers and retain the product
names (i.e. for the product name, use "Mozilla FireFox" not "Mozilla FireFox 1.0
PR", "Mozilla FireFox 0.9" etc.) and preserve the naming convention on the
registry... just a comment...
Comment 33 Simon Paquet [:sipaq] 2004-11-05 08:11:52 PST
*** Bug 266354 has been marked as a duplicate of this bug. ***
Comment 34 Simon Paquet [:sipaq] 2004-11-05 08:16:05 PST
Unfortunately this isn't fixed.
See the reports in comment 25, comment 28, comment 29, comment 30 and these
duped bugs: bug 267689 and bug bug 266354.

All these reports come from builds later than the checkin date.
Comment 35 Tom Hessman 2004-11-05 14:52:19 PST
Shouldn't the issue described by comment 25 (which I can also confirm on WinXP
upgrading from 0.10.1 to 1.0RC2) really be filed as a separate bug under the
Software Update component?  This bug is for when people use the installer to
install Firefox into the same directory as an older version, but comment 25 is
about Software Update not updating the version number in the Add/Remove Programs
entry, not the standalone installer.  Or is the same underlying code responsible
for both the installer and for Software Update?
Comment 36 Asa Dotzler [:asa] 2004-11-05 15:20:11 PST
Isn't it the case that this only impacts the RCs where all of these builds have
the same version number? I haven't been able to reproduce moving between major
versions. I don't think we're likely to block on this.
Comment 37 Thorsten Kaiser 2004-11-06 00:33:42 PST
@ #36
If I remember correctly, the Preview Release which I had installed had the
version number 0.10.1.
The version number of RC2 however is 1.0.
I would call this two different major versions, sorry.
And I DO think that this should be a blocker for 1.0 final. Definitely.

If there is anything I can do to help (apart from messing with the code) I'm
willing to contribute.

BTW: Does anyone have any idea what the effect of the doubled entries in the
registry will be? There does exist an uninstall entry in the registry only for
the PR, that's probably why I only see the PR appear under add/remove programs. 
Comment 38 uvr 2004-11-07 08:15:11 PST
I too see the behavior seen in @comment 25: the old entry for 1.0PR stayed
in Add/Remove Programs and no new entry was added for 1.0RC2.  As in 
@comment 37, I too think this is a blocker for final 1.0.
Comment 39 Pavel Penaz 2004-11-07 08:41:29 PST
I've just tried the following on a clean install of Windows XP.

1. I installed Firefox 1.0PR
2. Entry for Mozilla Firefox 1.0PR got created in Add/Remove dialog 
3. I installed todays nightly build of Firefox 1.0
4. Entry for Mozilla Firefox 1.0 appeared in Add/Remove dialog, entry for 1.0PR
remained there as well.
5. I installed the todays Firefox 1.0 nightly build again..
6. Suddenly entry for Firefox 1.0PR disappeared and there's just one entry in
the Add/Remove dialog

I've tried repeating this procedure two times and it consistently showed the
same results.. definitely there is something wrong.
Comment 40 Thorsten Kaiser 2004-11-09 09:25:16 PST
Ok, now we have 1.0 with this bug still being in...

I have just installed 1.0 on the computer at my work and now I have entries for
PR, RC2 and 1.0 Final in the registry. And still there is only PR as an
uninstall entry under add/remove.

Is it planned to clean up the registry entries with some future update? I would
certainly hope so.
Comment 41 Joel Peterson 2004-11-09 12:19:24 PST
I can confirm that it exists in 1.0 Final as well.
Comment 42 Kipp Howard 2004-11-09 12:32:21 PST
As a followup to comment 25...

In preparation to installing 1.0, when I ran the uninstall of "Mozilla Firefox
(1.0PR)" from "Add/Remove Programs", 1.0RC2 was successfully removed from my
system.  

So, as suggested in comment 32, if the name in the registry didn't contain the
version number, everything would work as expected, I believe.
Comment 43 Thorsten Kaiser 2004-11-09 13:38:34 PST
@ comment 42
Did you check in the registry if an entry for 1.0 RC2 or the PR still exists
even if you uninstalled RC2 with the PR entry first?
Comment 44 Kipp Howard 2004-11-10 13:08:44 PST
(In reply to comment #43)
> @ comment 42
> Did you check in the registry if an entry for 1.0 RC2 or the PR still exists
> even if you uninstalled RC2 with the PR entry first?

I confirmed that there are no left over Firefox keys in
"HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"

The keys in "HKEY_CURRENT_USER\Software\Mozilla\Mozilla Firefox" still contain
many different versions of Firefox (0.8, 0.9, 0.9.1, 0.9.3, 1.0PR, 1.0RC2, 1.0)
 I doubt that matters much.

The keys in "HKEY_LOCAL_MACHINE\SOFTWARE\Mozilla\Mozilla Firefox" are much
cleaner (1.0, 1.0RC2).

Comment 45 Worcester12345 2004-11-10 19:46:45 PST
Target Milestone 1.1? (need a bug blocking field with 1.1 also)
Comment 46 Alan Sanderson 2004-11-11 06:04:37 PST
As per <a
href="https://bugzilla.mozilla.org/show_bug.cgi?id=247884#c40">commment 40</a>
and <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=247884#c41">comment
41</a>, I can confirm upon upgrade from 1.0 RC 2 to 1.0 Final that this problem
is still pressent. Previously after upgrading to 1.0 RC 2, I had removed the
offending registry entries manually and upon upgrading to 1.0 Final (install in
same directory) the following registry entries are left in my registry;
HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla
Firefox (1.0RC2) - It is this one which is reponsible for the extraneous
add/remove entry. Also; 
HKEY_CURRENT_USER\Software\Mozilla\Mozilla Firefox 1.0RC2\bin
HKEY_CURRENT_USER\Software\Mozilla\Mozilla Firefox 1.0RC2\Extensions
HKEY_CURRENT_USER\Software\Mozilla\Mozilla Firefox 1.0RC2
HKEY_LOCAL_MACHINE\Software\Mozilla\Mozilla Firefox 1.0RC2\bin
HKEY_LOCAL_MACHINE\Software\Mozilla\Mozilla Firefox 1.0RC2\Extensions
HKEY_LOCAL_MACHINE\Software\Mozilla\Mozilla Firefox 1.0RC2
were left in the registry. <a
href="https://bugzilla.mozilla.org/show_bug.cgi?id=247884#c44">@44</a>, while
these registery entries don't matter nearly as much as the add/remove one I
think that they do matter. They add to registery bloat (however slightly), which
slows Windoze boxes down.
Comment 47 MK 2004-11-12 04:22:01 PST
(In reply to comment #23)
> It seems this bug is back with the release of Firefox 1.0 RC1 and RC2 builds. I
> have both RC1 and RC2 uninstall entries in the Add/Remove dialog. Can anyone
> confirm this?

I can - i was using 1.0 RC1 and then RC2 under Win2K (SP-4). I had both RC1 and
2 entries in Add/Remove dialog.
Comment 48 :Gavin Sharp [email: gavin@gavinsharp.com] 2004-11-14 09:52:38 PST
*** Bug 269808 has been marked as a duplicate of this bug. ***
Comment 49 Bill Mason 2004-11-15 11:42:53 PST
*** Bug 270018 has been marked as a duplicate of this bug. ***
Comment 50 Nick Berardi 2004-11-15 12:33:35 PST
A good implimentation example is Apple iTunes, they specify a GUI that allows
the Windows Installer always to find the old program and replace it.  Here is a
dump from the registry of my Mozilla Firefox and Apple iTunes.

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla
 Firefox (1.0)]
"DisplayName"="Mozilla Firefox (1.0)"
"UninstallString"="C:\\WINDOWS\\UninstallFirefox.exe /ua \"1.0 (en-US)\""
"DisplayIcon"="C:\\Program Files\\Mozilla Firefox\\firefox.exe,0"
"DisplayVersion"="1.0 (en-US)"
"Comment"="Mozilla Firefox"
"InstallLocation"="C:\\Program Files\\Mozilla Firefox"
"Publisher"="Mozilla"
"URLInfoAbout"="http://www.mozilla.org/"
"URLUpdateInfo"="http://www.mozilla.org/products/firefox/"

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{BE20E2
F5-1903-4AAE-B1AF-2046E586C925}]
"AuthorizedCDFPrefix"=""
"Comments"=""
"Contact"="AppleCare Support"
"DisplayVersion"="4.7.0.42"
"HelpLink"=hex(2):68,00,74,00,74,00,70,00,3a,00,2f,00,2f,00,77,00,77,00,77,00,\
  2e,00,69,00,6e,00,66,00,6f,00,2e,00,61,00,70,00,70,00,6c,00,65,00,2e,00,63,\
  00,6f,00,6d,00,2f,00,00,00
"HelpTelephone"="1-800-275-2273"
"InstallDate"="20041026"
"InstallLocation"="C:\\Program Files\\iTunes\\"
"InstallSource"="C:\\WINDOWS\\Downloaded Installations\\{8A232810-B5F1-48DD-
A63D-B439D7680D94}\\"
"NoModify"=dword:00000001
"NoRemove"=dword:00000001
"Publisher"="Apple Computer, Inc."
"Readme"=""
"Size"=""
"EstimatedSize"=dword:000033e7
"SystemComponent"=dword:00000001
"URLInfoAbout"="http://www.apple.com"
"URLUpdateInfo"="http://www.apple.com/itunes/"
"VersionMajor"=dword:00000004
"VersionMinor"=dword:00000007
"WindowsInstaller"=dword:00000001
"Version"=dword:04070000
"Language"=dword:00000409
"DisplayName"="iTunes"
Comment 51 Worcester12345 2004-11-15 18:51:56 PST
RealVNC would replace the old program as well. At least it did up through 3.3.7
I think.
Comment 52 Nick Berardi 2004-11-15 20:32:51 PST
Also if you goto
HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ you will
notice that some programs use GUID's and some done.  The ones with GUID's I
imagin are better maintained for install and upgrades.  Most of the programs
that don't have GUID's are older programs.  I think the GUID is a way to signal
to the Windows Installer that the program is already there or not already there
depending if it finds the GUID in the list.
Comment 53 Erik Walthinsen 2004-12-01 22:25:51 PST
To confirm this is a problem, I'm here updating a number of machines from 0.9.3
to 1.0 release, and someone else here is *CONVINCED* that installing the new
version without removing the old version is perfectly valid.  I know otherwise,
but cannot  convince him otherwise.  Removing the old version from the
Add/Remove Programs window removes *both*(?) versions and sometimes corrupts things.

This *MUST* be fixed before 1.0.1 or equivalent, or we'll have a huge amount of
really confused/unhappy users when they go to try to clean up their disk and
find that removing the old version kills Firefox completely.
Comment 54 Tuukka Tolvanen (sp3000) 2004-12-02 07:36:46 PST
*** Bug 272784 has been marked as a duplicate of this bug. ***
Comment 55 Bill Mason 2004-12-02 16:27:12 PST
*** Bug 272871 has been marked as a duplicate of this bug. ***
Comment 56 Brad Fults 2004-12-09 11:22:36 PST
I think comment 22 brings up the best idea. Because there can be multiple
Firefox/Thunderbird programs installed in multiple locations on a single
machine, I think there should only be a single "Mozilla Firefox ($version)"
entry in Add/Remove Programs (and the same for Thunderbird). This way the
versions and installation locations can be internally managed.

Clicking Change or Remove would pop up a custom dialog that would list all
installed versions/locations of the program and the ability to Remove or
Change/Upgrade? each. This would be an extremely powerful feature and would make
use of the multiple-installation ability.
Comment 57 Brad Fults 2004-12-09 11:24:10 PST
Created attachment 168333 [details]
Current visual representation (1.0)
Comment 58 Marek 2004-12-09 11:32:11 PST
(In reply to comment #56)
> I think comment 22 brings up the best idea. Because there can be multiple
> Firefox/Thunderbird programs installed in multiple locations on a single
> machine, I think there should only be a single "Mozilla Firefox ($version)"
> entry in Add/Remove Programs (and the same for Thunderbird). This way the
> versions and installation locations can be internally managed.

the solution is that you can identify program by text in registry, but that name
can also have kind of description which can contain version number.
as I mentioned in bug https://bugzilla.mozilla.org/show_bug.cgi?id=272784
it should just write to one and the same registry entry: HKLM
"Software\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox"
which contain several values among others point to uninstall program string
value "UninstallString" (which currently seem to point to a bad program too),
and string value "DisplayName" which would contain the description of the
program in my case "Mozilla Firefox (1.0)". Next version will write to exactly
same registry key, but overwrite string value "DisplayName" with new description
(like "Mozilla Firefox (1.1)").


Comment 59 Kyle Hamilton 2004-12-09 11:55:57 PST
(In reply to comment #58)

> the solution is that you can identify program by text in registry, but that name
> can also have kind of description which can contain version number.
> as I mentioned in bug https://bugzilla.mozilla.org/show_bug.cgi?id=272784
> it should just write to one and the same registry entry: HKLM
> "Software\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox"
> which contain several values among others point to uninstall program string
> value "UninstallString" (which currently seem to point to a bad program too),
> and string value "DisplayName" which would contain the description of the
> program in my case "Mozilla Firefox (1.0)". Next version will write to exactly
> same registry key, but overwrite string value "DisplayName" with new description
> (like "Mozilla Firefox (1.1)").

I'm not at all certain that this would be the correct way to go.  The basic
premise is:

We only want one Add/Remove option in the list.

As it stands right now, there is no way to have a side-by-side installation in
which both installations are managed under Add/Remove Programs.

There are two solutions:

1) We could make the path to Firebird part of the DisplayName (to provide some
feedback as to which installation is being modified), or
2) We could leave one entry in there "Mozilla Firefox", and have that point to a
DLL or EXE that scans the registry for installed versions, then provides a means
of installing, upgrading, or uninstalling any of them.  (upon last version
removal, the uninstaller would need to remove itself and the Add/Remove Programs
entry.)

Sun's JRE has the same sort of setup.  (Even if you have multiple versions of
the JRE installed, each one will still give you the option of removing any of
the other versions.)

As an administrator, I would also like the ability to pass a flag to the
uninstaller to specify which path or version should be removed.  (please, no
"based on place in list" options... it's hard to script that if some machines
have more installations than others.)
Comment 60 Brad Fults 2004-12-09 12:15:21 PST
Created attachment 168337 [details]
Proposed Dialog

A single dialog that will manage the removal/update of all installed versions
of Firefox (and a similar one for Thunderbird). This would mean that there
would only be a single "Mozilla Firefox" entry in the Add/Remove Programs list
and when "Change/Remove" is clicked, this dialog would pop up.
Comment 61 Olaf van der Spek 2004-12-09 12:17:37 PST
Should it be one dialog per component or one dialog for all Mozilla software?
Comment 62 Marek 2004-12-09 12:18:31 PST
(In reply to comment #59)
> I'm not at all certain that this would be the correct way to go.  The basic
> premise is:
> 
> We only want one Add/Remove option in the list.
> 
> As it stands right now, there is no way to have a side-by-side installation in
> which both installations are managed under Add/Remove Programs.
> 
> There are two solutions:
> 
> 1) We could make the path to Firebird part of the DisplayName (to provide some
> feedback as to which installation is being modified), or
> 2) We could leave one entry in there "Mozilla Firefox", and have that point to a
> DLL or EXE that scans the registry for installed versions, then provides a means
> of installing, upgrading, or uninstalling any of them.  (upon last version
> removal, the uninstaller would need to remove itself and the Add/Remove Programs
> entry.)
> 
> Sun's JRE has the same sort of setup.  (Even if you have multiple versions of
> the JRE installed, each one will still give you the option of removing any of
> the other versions.)
> 
> As an administrator, I would also like the ability to pass a flag to the
> uninstaller to specify which path or version should be removed.  (please, no
> "based on place in list" options... it's hard to script that if some machines
> have more installations than others.)

99.9% of users when they upgrade from 1.0RC1 to 1.0 want the previous
installation to be overwritten. The proposed installation path is exactly the
same in both version which implies that the default action is upgrade not
side-by-side installation. So the two choices are:
- go with 99.9% and write to the same registry key for all browsers
- go with the rest, but then change the proposed installation path accordingly
(meaning to "c:\Program Files\Mozilla Firefox 1.0" or "c:\Program Files\Mozilla
Firefox 1.0RC1" etc. with version number just as in the registry).

With Java things are little bit differently because when they change from 1.3 to
1.4 to 1.5 those are rather revolutionary (not evolutionary) changes and you
will definitely see different behaviour of the same java binary of an advanced
program between versions.
Comment 63 Brad Fults 2004-12-09 12:24:23 PST
(In reply to comment #61)
> Should it be one dialog per component or one dialog for all Mozilla software?

I would make it per component, but this is definitely up for debate among the
developers.
Comment 64 Brad Fults 2004-12-09 12:29:09 PST
I don't mean to spam, but for clarification, my proposal accounts for a single
version per installation location. So if you install Firefox 1.1 in C:\Program
Files\Mozilla Firefox\ and 1.0 is already installed there, 1.1 will overwrite it
in the Remove/Change dialog. Each entry in the list of that dialog is a distinct
installation location.
Comment 65 Robin Monks 2005-01-11 10:53:35 PST
*** Bug 271247 has been marked as a duplicate of this bug. ***
Comment 66 Worcester12345 2005-01-12 13:49:34 PST
Shouldn't this get "Aviary Landing" key words? It is fixed on the Aviary, and
was reopened around the time of landing. Hello?
Comment 67 Michael Lefevre 2005-01-12 13:56:05 PST
"It is fixed on the Aviary" - no, it wasn't. So it's not an aviary landing issue.
Comment 68 jevons 2005-01-31 00:36:19 PST
If you uninstall the older version, it deletes the newer version.  I had to
reinstall everything!!!!!
Comment 69 Simon Paquet [:sipaq] 2005-02-25 01:39:51 PST
*** Bug 280841 has been marked as a duplicate of this bug. ***
Comment 70 Simon Paquet [:sipaq] 2005-02-25 01:39:54 PST
*** Bug 283577 has been marked as a duplicate of this bug. ***
Comment 71 Simon Paquet [:sipaq] 2005-02-25 01:40:21 PST
*** Bug 247708 has been marked as a duplicate of this bug. ***
Comment 72 trixter4289 2005-02-25 08:53:43 PST
This is not fixed.  I just installed 1.01 over 1.0 to the same folder and in my
Add/Remove Programs list I had:

Mozilla Firefox 1.0
Mozilla Firefox 1.01

The 1.0 should have been removed and it was not.
Comment 73 Daniel Veditz [:dveditz] 2005-02-25 12:10:24 PST
The installer back-end should have code to do this correctly already, the
Suite/Netscape installer got this right.
Comment 74 Jo Hermans 2005-02-28 15:10:09 PST
*** Bug 284162 has been marked as a duplicate of this bug. ***
Comment 75 Phil Hibbs 2005-03-03 04:00:31 PST
I voted for this bug, but ever since then I have received an email every time
someone does anything to it, such as removing their name from the CC list. My
email address isn't on the CC list, so I can't stop this from happening. I am
therefore rescinding my vote, because it isn't worth the hassle of the emails
that it generates. I know, I should report this as a bug in bugzilla, but I
really don't have the time.
Comment 76 PikeUK 2005-03-03 05:58:05 PST
*** Bug 266508 has been marked as a duplicate of this bug. ***
Comment 77 Mike Kaply [:mkaply] 2005-03-03 07:00:48 PST
This is a major bug. One would expect a user going into control panel to think
"I upgraded, I can remove 1.0"
Comment 78 Chase Phillips 2005-03-03 09:45:20 PST
Nominating blocking-aviary1.0.2.
Comment 79 Wayne Mery (:wsmwk, NI for questions) 2005-03-04 10:14:02 PST
mod summary
Comment 80 Wayne Mery (:wsmwk, NI for questions) 2005-03-04 10:19:27 PST
*** Bug 284754 has been marked as a duplicate of this bug. ***
Comment 81 Greg K Nicholson [:gkn] 2005-03-05 13:00:28 PST
(In reply to comment #75)
> I voted for this bug, but ever since then I have received an email every time
> someone does anything to it

Change your prefs - https://bugzilla.mozilla.org/userprefs.cgi?tab=email
Comment 82 Chase Phillips 2005-03-07 17:46:50 PST
(In reply to comment #78)
> Nominating blocking-aviary1.0.2.

I'm plusing these nominations.  This is confusing our users and leading to bad
experience.  It should be fixed in our next release (1.0.2 if there is one, 1.1
otherwise).
Comment 83 Worcester12345 2005-03-08 07:53:22 PST
(In reply to comment #77)
> This is a major bug. One would expect a user going into control panel to think
> "I upgraded, I can remove 1.0"

Not only that, it gives an error which can't be avoided except through going
into regedit. That's not end-user friendly.
Comment 84 alex 2005-03-08 09:20:56 PST
Then the fix for this could be to remove the previous version from the registry,
but the installer should uninstall the privious version anyway before
overwriting the files. 
Comment 85 Mark Janssen 2005-03-08 11:49:37 PST
I usually remove all old versions. It works, but when I totally remove Firefox
it also removes some plugins, though.
Comment 86 Mike Kaply [:mkaply] 2005-03-09 11:01:31 PST
*** Bug 285413 has been marked as a duplicate of this bug. ***
Comment 87 Chase Phillips 2005-03-09 16:46:29 PST
As made clear in the screenshot and elsewhere in this bug, this problem also
affects Thunderbird and Suite.
Comment 88 HEAT84 2005-03-09 21:29:50 PST
Why is it so hard for the programmers to get this right? It would be like me
knowing the value of pi but not 1+1=2. If they can't fix it why don't they just
use installsheild or Wise instead of their own installer?
Comment 89 Mike Goodspeed 2005-03-09 23:12:41 PST
This bug has been verified and is being worked on.  Please do not post comments
unless you are able to help fix this bug.  Thanks.
Comment 90 Gervase Markham [:gerv] 2005-03-10 03:14:59 PST
Ideally, a fix for this bug would also remove any "duplicate" entries (i.e. ones
pointing to the same directory) in Add/Remove programs, leaving only the most
recent.

So if you had
Firefox 0.9
Firefox 1.0
Firefox 1.0.1
all pointing to C:\Program Files\Mozilla Firefox, then it would remove the first
two of those.

Gerv
Comment 91 Marek 2005-03-10 04:48:30 PST
(In reply to comment #89)
> This bug has been verified and is being worked on.  Please do not post comments
> unless you are able to help fix this bug.  Thanks.

I posted a solution to this bug in comment #58
it requires removing couple of numbers in notepad - that's all
Comment 92 Worcester12345 2005-03-10 10:16:10 PST
(In reply to comment #12)
> There are two options here, uninstall the old version or just remove the listing
> if the new install is on top of the old one. I recommend uninstall. That solves
> this and other problems.
> 
> We should get this for 1.0.

We should get this for 1.1.
Comment 93 Doug Wright 2005-03-10 10:33:37 PST
It's already blocking 1.1 - please only comment if you've got something useful
to add to the bug - thanks!
Comment 94 Ulrich Windl 2005-03-17 07:40:28 PST
(In reply to comment #72)
> This is not fixed.  I just installed 1.01 over 1.0 to the same folder and in my
> Add/Remove Programs list I had:
> 
> Mozilla Firefox 1.0
> Mozilla Firefox 1.01
> 
> The 1.0 should have been removed and it was not.

The minimum to expect is to display some plain text instructions mentioning what
to do if Firefox is already installed (better detect that!). Ideally I'd expect
the installer to remove the old version, and then install the new one.
What makes the situation described above worse, is that after you've virtually
uninstalled Firefox 1.0, Firefox-1.0.1 files were removed in reality (without
any warning). Also the control panel refuses to remove that Firefox-1.0.1 entry
then (uninstallinformation is gone). The only solution is to install
Firefox-1.0.1 at the same location again it seems. There must be better ways in
year 2005, several years after inventing sliced bread ;-)
Comment 95 Tim Meader 2005-03-17 13:37:53 PST
I'm sure I'll get some heat for this, but I'm thinking that if the proposed
solution in #58 is immediately implementable, I don't think the arguments
against it in #59 are valid. For 99.9 percent of Firefox's installed base, they
DO NOT CARE about having multiple versions installed side by side. I know that
IE doesn't give users this option, so to the lay person (ie - most of the 28+
million new Firefox users), they will not miss the ability to install more than
one version of Firefox on their systems... because they had no idea you could do
that in the first place. IF the proposed fix in #58 is simple, then holding up a
patch for it based solely on the fact that it would not allow people with
multiple Firefox installations to have each install show up in the Add/Remove
Programs dialog, is a bad idea. The users who are installing multiple versions
are the ones who already KNOW HOW to go into the regsitry and uninstall all
traces of Firefox, so for them the GUI uninstall interface is a plus, not a
requirement. For regular users though, when you see 2 or more (with the
forthcoming 1.0.2) entires in Add/Remove, and NO OTHER Windows program shows
this behavior, it is incredibly confusing. I've personally fielded 4 seperate
inquiries from relatives so far wondering if they did something wrong when
upgrading. And upgrade process should not leave the user questioning whether it
completed successfully. As it stands, this is a GLARING issue with Firefox, and
especially with 1.0.1 and the soon to be coming 1.0.2, this will only look more
unprofessional as time goes on.

If the fix mentioned in #58 is NOT trivial, and the current work that is being
done on fixing this stands to be completed within the same timeframe, please
disregard this post.
Comment 96 timeless 2005-03-17 18:30:41 PST
actually, you're wrong. ie5 was available for sidebyside use. as were certain
other versions at certain times.
Comment 97 DaCypher 2005-03-18 04:39:34 PST
(In reply to comment #95)
> I'm sure I'll get some heat for this, but I'm thinking that if the proposed
> solution in #58 is immediately implementable, I don't think the arguments
> against it in #59 are valid. For 99.9 percent of Firefox's installed base, they
> DO NOT CARE about having multiple versions installed side by side. I know that
> IE doesn't give users this option, so to the lay person (ie - most of the 28+
> million new Firefox users), they will not miss the ability to install more than
> one version of Firefox on their systems... because they had no idea you could do
> that in the first place. IF the proposed fix in #58 is simple, then holding up a
> patch for it based solely on the fact that it would not allow people with
> multiple Firefox installations to have each install show up in the Add/Remove
> Programs dialog, is a bad idea. The users who are installing multiple versions
> are the ones who already KNOW HOW to go into the regsitry and uninstall all
> traces of Firefox, so for them the GUI uninstall interface is a plus, not a
> requirement. For regular users though, when you see 2 or more (with the
> forthcoming 1.0.2) entires in Add/Remove, and NO OTHER Windows program shows
> this behavior, it is incredibly confusing. I've personally fielded 4 seperate
> inquiries from relatives so far wondering if they did something wrong when
> upgrading. And upgrade process should not leave the user questioning whether it
> completed successfully. As it stands, this is a GLARING issue with Firefox, and
> especially with 1.0.1 and the soon to be coming 1.0.2, this will only look more
> unprofessional as time goes on.
> 
> If the fix mentioned in #58 is NOT trivial, and the current work that is being
> done on fixing this stands to be completed within the same timeframe, please
> disregard this post.

I think the only situation where solution in comment 58 could cause a problem is
if the user installs a new version to a different path.  So now the user
(probably unknowingly) has two installations of Firefox in different
directories, but this should not really present a problem since a user that
would probably do this wouldn't notice the difference (i.e. all shortcuts would
be pointing to the new install).  However, now the user has an extra copy of
Firefox floating around (again, probably something that this user would never
notice).

I think similar ideas may have been mentioned, but maybe we should just pass a
version number to the uninstaller and leave multiple entries in Add/Remove
Programs?  That way, if the uninstaller receives a version number that is less
than its current version (or no version number for older versions that didn't do
this), then it will simply remove the entry from the list.  This goes against
what you said about not having more than one entry in Add/Remove Programs for
the same application, so this may not be the greastest way to go...
Comment 98 Max 2005-03-18 14:41:44 PST
Only a technically advanced user would want multiple versions of FireFox
installed alongside each other, in which case they should use the zip file of
FireFox.
Comment 99 Doug Wright 2005-03-18 14:55:22 PST
(In reply to comment #98)
> Only a technically advanced user would want multiple versions of FireFox
> installed alongside each other, in which case they should use the zip file of
> FireFox.

Except that 1.1 won't have any zipped builds for people to use -
https://bugzilla.mozilla.org/show_bug.cgi?id=283676#c3
Comment 100 Max 2005-03-18 15:03:22 PST
(In reply to comment #99)
> (In reply to comment #98)
> > Only a technically advanced user would want multiple versions of FireFox
> > installed alongside each other, in which case they should use the zip file of
> > FireFox.
> 
> Except that 1.1 won't have any zipped builds for people to use -
> https://bugzilla.mozilla.org/show_bug.cgi?id=283676#c3

The other question is why a user would want multiple builds installed? At the
end of a day, an installer's job is to install and upgrade any previous
versions, and that includes add/remove entries. If they want to have multiple
builds installed for whatever reason, they're probably a developer and could
compile or whatever.
Comment 101 timeless 2005-03-18 17:37:38 PST
funny. some developers are paid to make sure web sites support old versions of
web browsers. some developers are paid to make plugins that work in multiple
versions of browsers.
Comment 102 C.S. Chen 2005-03-24 00:18:12 PST
Old versions may have security flaws, like the recently obsoleted Firefox
1.0/1.0.1. IMHO Mozilla shouldn't support the use of insecure versions of
software. Unless Mozilla is willing to provide an old but secure version in the
future (like BIND 4.9.11/8.4.6 vs 9.3.1), the installer shall remove the old
version once the user installs a newer version.
Comment 103 Nick Berardi 2005-03-24 06:29:17 PST
The problem is that the old version isn't on the computer any longer but the
registry entry is still present.  You can go in to the registry and delete the
entry for your self.  However this isn't an option for most users.

I don't know why Mozilla is being so stubern and not implimenting the Windows
Installer to it's full capability.  They could easily generate an installer with
an Upgrade GUID and then they wouldn't have to worry about this problem.  There
are also many solutions out there, that are OSS, that can help:

http://sourceforge.net/projects/wix
http://sourceforge.net/projects/nsis

Both of these installers are generated from XML, and both allow you to provide a
Product GUID and a Upgrade GUID.  The GUID's are there to uniquely id the
install so that it can be replaced by the MSI installer.  This is nothing that
Mozilla has to do, because the MSI software handles all of this.  Mozilla just
has to take the initiative and generate the GUID's.

This is the registry entry for FireFox:

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla
Firefox (1.0.2)]
"DisplayName"="Mozilla Firefox (1.0.2)"
"UninstallString"="C:\\WINDOWS\\UninstallFirefox.exe /ua \"1.0.2 (en-US)\""
"DisplayIcon"="C:\\Program Files\\Mozilla Firefox\\firefox.exe,0"
"DisplayVersion"="1.0.2 (en-US)"
"Comment"="Mozilla Firefox"
"InstallLocation"="C:\\Program Files\\Mozilla Firefox"
"NoModify"=hex(4):
"NoRepair"=hex(4):
"Publisher"="Mozilla"
"URLInfoAbout"="http://www.mozilla.org/"
"URLUpdateInfo"="http://www.mozilla.org/products/firefox/"

This is a registry entry for nDoc an OSS software for .Net, that offers upgrade,
and repair, notice the difference.  Also notice the GUID instead of the FireFox
name at the top:

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{218A55DF-0FF0-4BBE-9020-AD2E57B2B9A6}]
"AuthorizedCDFPrefix"=""
"Comments"="Code Documentation Generator for .NET"
"Contact"="NDoc"
"DisplayVersion"="1.3.1"
"HelpLink"=hex(2):68,00,74,00,74,00,70,00,3a,00,2f,00,2f,00,6e,00,64,00,6f,00,\
  63,00,2e,00,73,00,6f,00,75,00,72,00,63,00,65,00,66,00,6f,00,72,00,67,00,65,\
  00,2e,00,6e,00,65,00,74,00,2f,00,00,00
"HelpTelephone"=""
"InstallDate"="20050323"
"InstallLocation"=""
"InstallSource"="M:\\Users\\Nick\\Desktop\\"
"ModifyPath"=hex(2):4d,00,73,00,69,00,45,00,78,00,65,00,63,00,2e,00,65,00,78,\
  00,65,00,20,00,2f,00,49,00,7b,00,32,00,31,00,38,00,41,00,35,00,35,00,44,00,\
  46,00,2d,00,30,00,46,00,46,00,30,00,2d,00,34,00,42,00,42,00,45,00,2d,00,39,\
  00,30,00,32,00,30,00,2d,00,41,00,44,00,32,00,45,00,35,00,37,00,42,00,32,00,\
  42,00,39,00,41,00,36,00,7d,00,00,00
"Publisher"="NDoc"
"Readme"=""
"Size"=""
"EstimatedSize"=dword:0000164e
"UninstallString"=hex(2):4d,00,73,00,69,00,45,00,78,00,65,00,63,00,2e,00,65,00,\
  78,00,65,00,20,00,2f,00,49,00,7b,00,32,00,31,00,38,00,41,00,35,00,35,00,44,\
  00,46,00,2d,00,30,00,46,00,46,00,30,00,2d,00,34,00,42,00,42,00,45,00,2d,00,\
  39,00,30,00,32,00,30,00,2d,00,41,00,44,00,32,00,45,00,35,00,37,00,42,00,32,\
  00,42,00,39,00,41,00,36,00,7d,00,00,00
"URLInfoAbout"="http://ndoc.sourceforge.net/"
"URLUpdateInfo"=""
"VersionMajor"=dword:00000001
"VersionMinor"=dword:00000003
"WindowsInstaller"=dword:00000001
"Version"=dword:01030001
"Language"=dword:00000409
"DisplayName"="NDoc 1.3"

I call for the FireFox developers to stop trying to make an elogant solution
that and do this right.  This is one of the major hurdles that is holding back
wide spread adoption in major organizations, the predictability of the installer
to not leave unnessisary **** all of the system.  

On a side not doesn't anybody have the latest release for Netscape based off of
FireFox?  Does the Netscape Installer fix this issue?
Comment 104 Jo Hermans 2005-03-24 06:35:36 PST
*** Bug 287553 has been marked as a duplicate of this bug. ***
Comment 105 Frank 2005-03-24 07:04:10 PST
In reply to comment 103:

The very first line of the registry entries you posted is the problem:

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla
Firefox (1.0.2)]

When the version number would be left out of this key it would be a solution.
But that is only a solution when installed in a same directory as the previous
version.
Comment 106 Max 2005-03-24 07:56:57 PST
This is getting silly. This is obviously a stupid bug that could easily be
fixed, so when will it be fixed?
Comment 107 Doug Wright 2005-03-24 08:12:56 PST
(In reply to comment #106)
> This is getting silly. This is obviously a stupid bug that could easily be
> fixed, so when will it be fixed?

Please read https://bugzilla.mozilla.org/etiquette.html before commenting
furthur on this (or any bug).
Comment 108 Chris Blore 2005-03-24 08:27:04 PST
Please do not post additional comments asking why the bug has not been fixed. It
is currently blocking both a 1.0.3 and a 1.1 release and therefore is in line to
be patched before any of these can be made. 

Everybody knows that this is an important bug but additional posts and
discussion is not required unless it pertains to a new manifestation or method
of solving it.
Comment 109 C.S. Chen 2005-03-24 09:26:38 PST
(In reply to comment #108)
> Please do not post additional comments asking why the bug has not been fixed. It
> is currently blocking both a 1.0.3 and a 1.1 release and therefore is in line to
> be patched before any of these can be made. 

Well, in comment #82 chase states that this bug is blocking 1.0.2, but now we
have 1.0.2 without solution of this bug. Hope the bug will be solved in the next
release.

Besides, I still suggest the installer to detect old/insecure installation of
software and then upgrade it; the option to change install location shouldn't be
available in this situation. Installer of the updated software shall not expose
the user to potential security risks.
Comment 110 Kris Silver 2005-03-24 14:55:33 PST
I personally had to update 3 computers to version 1.0.1, then again to 1.0.2! 
These xp machines werent even prompted to upgrade, I had to find out and then do
it for my friends and family whom I had gotten to use firefox.  There are now 3
listings of firefox in add/remove programs.  The upgrade is ridiculous, I'm
confused as to what Mozilla are calling update, or auto update, because I dont
know any friend that has had an auto update or any kind of smooth upgrade.  The
upgrade is basically re-installiing all over again, which gives the windows
desktop a duplicate icon of firefox.  That in particular is very shoddy and
putting my friends off continuing to use and promte fx.  

Microsoft's anti-spyware program already lists Mozilla firefox as a dangerous
application with in-sufficient security updates.  Now we know this is a
ridiculous statement and misleading people.  But the fact is this kind of thing
just gives that argument more punch, the media and public have been fooled by
microsoft before, and if were not careful microsoft will be all over this issue
if it continues.  People expect a smooth auto update feature in quality
software.  Adobe, IE, Nero, all manage it fine, Mozilla are quality software
developers, this needs to be fixed before these really does some damage and gets
a stinky write up, and bang Mozilla are the bad guys.  I and my friends are
un-installing and going to competition if this happens again, the time saved
using tabs is wasted re-installing every month.

(In reply to comment #109)
> (In reply to comment #108)
> > Please do not post additional comments asking why the bug has not been fixed. It
> > is currently blocking both a 1.0.3 and a 1.1 release and therefore is in line to
> > be patched before any of these can be made. 
> 
> Well, in comment #82 chase states that this bug is blocking 1.0.2, but now we
> have 1.0.2 without solution of this bug. Hope the bug will be solved in the next
> release.
> 
> Besides, I still suggest the installer to detect old/insecure installation of
> software and then upgrade it; the option to change install location shouldn't be
> available in this situation. Installer of the updated software shall not expose
> the user to potential security risks.
Comment 111 Kris Silver 2005-03-24 14:57:11 PST
I personally had to update 3 computers to version 1.0.1, then again to 1.0.2! 
These xp machines werent even prompted to upgrade, I had to find out and then do
it for my friends and family whom I had gotten to use firefox.  There are now 3
listings of firefox in add/remove programs.  The upgrade is ridiculous, I'm
confused as to what Mozilla are calling update, or auto update, because I dont
know any friend that has had an auto update or any kind of smooth upgrade.  The
upgrade is basically re-installiing all over again, which gives the windows
desktop a duplicate icon of firefox.  That in particular is very shoddy and
putting my friends off continuing to use and promte fx.  

Microsoft's anti-spyware program already lists Mozilla firefox as a dangerous
application with in-sufficient security updates.  Now we know this is a
ridiculous statement and misleading people.  But the fact is this kind of thing
just gives that argument more punch, the media and public have been fooled by
microsoft before, and if were not careful microsoft will be all over this issue
if it continues.  People expect a smooth auto update feature in quality
software.  Adobe, IE, Nero, all manage it fine, Mozilla are quality software
developers, this needs to be fixed before these really does some damage and gets
a stinky write up, and bang Mozilla are the bad guys.  I and my friends are
un-installing and going to competition if this happens again, the time saved
using tabs is wasted re-installing every month.

(In reply to comment #109)
> (In reply to comment #108)
> > Please do not post additional comments asking why the bug has not been fixed. It
> > is currently blocking both a 1.0.3 and a 1.1 release and therefore is in line to
> > be patched before any of these can be made. 
> 
> Well, in comment #82 chase states that this bug is blocking 1.0.2, but now we
> have 1.0.2 without solution of this bug. Hope the bug will be solved in the next
> release.
> 
> Besides, I still suggest the installer to detect old/insecure installation of
> software and then upgrade it; the option to change install location shouldn't be
> available in this situation. Installer of the updated software shall not expose
> the user to potential security risks.
Comment 112 Ng Ming Hong 2005-03-24 23:54:24 PST
We know this problem is series. Please stop giving unnecessary comments unless
you are offering help, i.e. writing a patch or something. Bugzilla is not a
discussion forum.
Comment 113 Mark Janssen 2005-03-25 03:47:05 PST
(In reply to comment #111)
> Microsoft's anti-spyware program already lists Mozilla firefox as a dangerous
> application with in-sufficient security updates.

I do not want to start a flamewar nor want to post another off-topic comment but
what you are saying is totally not true.
http://www.google.com/search?q=microsoft+antispyware+firefox+hoax
Comment 114 Max 2005-03-25 09:17:03 PST
(In reply to comment #113)
> (In reply to comment #111)
> > Microsoft's anti-spyware program already lists Mozilla firefox as a dangerous
> > application with in-sufficient security updates.
> 
> I do not want to start a flamewar nor want to post another off-topic comment but
> what you are saying is totally not true.
> http://www.google.com/search?q=microsoft+antispyware+firefox+hoax

There is some truth in the sense that Microsoft AntiSpyware asks if you want it
to be added to startup or something like that, ie. it doesn't do it automatically.
Comment 115 Worcester12345 2005-03-25 12:29:47 PST
(In reply to comment #112)
> We know this problem is series. Please stop giving unnecessary comments unless
> you are offering help,

I tried to add the "helpwanted" key word, but it wouldn't let me.



(In reply to comment #112)
> ... Bugzilla is not a
> discussion forum.

? https://bugzilla.mozilla.org/show_bug.cgi?id=215379 ?

;-)
Comment 116 Brian Ryner (not reading) 2005-03-25 16:08:36 PST
taking
Comment 117 Brian Ryner (not reading) 2005-03-25 16:11:40 PST
Created attachment 178640 [details] [diff] [review]
fix (firefox and thunderbird)
Comment 118 Ben Goodger (use ben at mozilla dot org for email) 2005-03-25 16:16:46 PST
Comment on attachment 178640 [details] [diff] [review]
fix (firefox and thunderbird)

r=ben@mozilla.org
Comment 119 Brian Ryner (not reading) 2005-03-25 16:22:08 PST
Comment on attachment 178640 [details] [diff] [review]
fix (firefox and thunderbird)

Requesting approval... I'm not sure what the plan is for landing 1.0.3 patches
or which branch to land on...
Comment 120 Asa Dotzler [:asa] 2005-03-25 16:53:55 PST
drivers will review this after it's been on the trunk for a bit longer and when
we're a bit closer to the next security release. Thanks, bryner. I think we'll
certainly want to take this.
Comment 121 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-03-26 23:04:42 PST
*** Bug 287887 has been marked as a duplicate of this bug. ***
Comment 122 Simon Paquet [:sipaq] 2005-03-27 07:12:18 PST
*** Bug 287864 has been marked as a duplicate of this bug. ***
Comment 123 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-03-27 17:54:02 PST
*** Bug 287968 has been marked as a duplicate of this bug. ***
Comment 124 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-03-28 21:37:53 PST
*** Bug 288116 has been marked as a duplicate of this bug. ***
Comment 125 Simon Paquet [:sipaq] 2005-03-29 01:34:34 PST
*** Bug 288125 has been marked as a duplicate of this bug. ***
Comment 126 Asa Dotzler [:asa] 2005-03-29 10:27:58 PST
*** Bug 288125 has been marked as a duplicate of this bug. ***
Comment 127 Chris Dunigan 2005-03-29 14:30:39 PST
I noticed this too, and in fact stupidly removed FireFox from my machine in 
the process! Add/Remove Programs showed three separate installations/versions 
of FireFox - each at like 15mb a piece. Well wanting to conserve precious hard 
disk space I removed the oldest version. Poof! They all went away at the same 
time... DOWH!

Fortunately a re-install of FF and all my saved bookmarks were still there. 
Phew!

Comment 128 David Baron :dbaron: ⌚️UTC-7 2005-04-01 20:57:47 PST
Fix checked in to AVIARY_1_0_1_20050124_BRANCH, 2005-04-01 18:48 -0800.

bryner also checked this into the trunk on 2005-03-25 20:48 -0800.
Comment 129 Jay Patel [:jay] 2005-04-02 01:21:54 PST
This seems partially fixed on the Aviary branch - Mozilla/5.0 (Windows; U;
Windows NT 5.1; en-US; rv:1.7.7) Gecko/20050401 Firefox/1.0.3

Steps:
1. Installed 1.0, 1.0.1 and 1.0.2 in the same location and ended up with 3
entries in Add/Remove Programs.
2. Installed 1.0.3 to the same location
3. The 1.0.2 entry was replaced with 1.0.3, but 1.0 and 1.0.1 entries were still
left in Add/Remove Programs. However, there was no way for me to "accidently"
remove the latest version because I was not able to uninstall from the 1.0 or
1.0.1 entries (I got an error that said "0: Uninstall log folder not found: 
<the reg key for the 1.0.1>).

So, we now do replace the previous version entry with the latest version, but
any older entries remain.  Could we possibly check for the install path of all
older Firefox versions and remove their entries as well if the current version
is installed in the same location?
Comment 130 Asa Dotzler [:asa] 2005-04-02 09:59:03 PST
This doesn't clean up the mess we've made in the past but it prevents the
problem going forward. That's good enough for me for 1.0.3. 
Comment 131 Max 2005-04-02 11:01:26 PST
The next FireFox installer released should remove all previous entries lying
around, be it 1.0.2, 1.0.1, 1.0, 1.0 PR etc.
Comment 132 Will Sargent 2005-04-02 11:51:31 PST
Seconded.  The current patch doesn't clean everything up because it still leaves
the vestigal entries in the Add/Remove Programs behind.  Maybe another bug
should be filed for that specific functionality, but something's going to have
to clean it up.
Comment 133 Kipp Howard 2005-04-02 14:49:55 PST
It seems I'm always the odd one out...  Here are my experiences with the new
builds that were made available via Asa's blog today:

* Before installing 1.0.2 I had only one entry in Add/Remove Programs for 1.0.1
* I purposely didn't uninstall 1.0.1 before installing 1.0.2
* After installation of 1.0.2 there were two entries within my Add/Remove
Programs (1.0.1 and 1.0.2).
* Again I didn't uninstall either 1.0.1 or 1.0.2 before installing the 1.0.3.
* After installation of 1.0.3, only 1.0.3 was left in Add/Remove Programs.

So from my perspective, the fix is working as expected.

PS: I'm using WinXP SP2.
Comment 134 Erlendur S Thorsteinsson 2005-04-02 15:47:29 PST
Created attachment 179428 [details]
Show Updates

Shouldn't the Add/Remove entry for Firefox behave in a similar way to the
Add/Remove entry for, say, Office 2003?

The left part of the attachment (Show Updates, combined screenshots) shows the
MSO2K3 entry when the "Show updates" checkbox is not checked and the right part
when it is checked (Windows XP SP2).

Similarly, shouldn't the main entry for Firefox be "Mozilla Firefox 1.0" and
when "Show updates" is checked it would also show "Mozilla Firefox Update
1.0.1", "Mozilla Firefox Update 1.0.2", etc?  When Firefox 1.1 is released the
main entry would be replaced with "Mozilla Firefox 1.1" and the update entries
removed, until Firefox 1.1.1 is released and "Mozilla Firefox Update 1.1.1"
would be added?
Comment 135 Greg K Nicholson [:gkn] 2005-04-02 16:29:15 PST
(In reply to comment #134)
> Shouldn't the Add/Remove entry for Firefox behave in a similar way to the
> Add/Remove entry for, say, Office 2003?

I agree that seems to be the optimal solution, but that would be a separate
enhancement bug.
Comment 136 Jay Patel [:jay] 2005-04-02 17:33:44 PST
I tried to reproduce again and this time I saw the same thing as Kipp: all of my
older entries were removed correctly.  The only thing I did different was
completely remove the install directory from my earlier testing (I'm guessing
some uninstall logs/files were left behind last night...which could explain the
weird behavior).  Starting from scratch, I installed 1.0, 1.0.1, and 1.0.2 into
the same default "Mozilla Firefox" directory.  Installing 1.0.3 removed the 3
older entries...so marking this verified.

If anyone still has minor problems with this, please log a new bug.
Comment 137 Jeremy Chadwick 2005-04-03 11:51:29 PDT
This problem applies to not just Firefox, but all Mozilla products 
(Thunderbird, etc.).

Wonderful "oversight", guys.
Comment 138 Matthias Versen [:Matti] 2005-04-03 12:40:18 PDT
*** Bug 288870 has been marked as a duplicate of this bug. ***
Comment 139 Worcester12345 2005-04-04 10:13:29 PDT
(In reply to comment #131)
> The next FireFox installer released should remove all previous entries lying
> around, be it 1.0.2, 1.0.1, 1.0, 1.0 PR etc.

What about .7, .8, .9?
Comment 140 Michael Lefevre 2005-04-04 10:37:37 PDT
> What about .7, .8, .9?

Installing over the top of 0.8/0.9, particularly if any extensions were
installed, usually messes things up anyway, and isn't supported.  No point
fixing this issue if nothing else works.  Firebird 0.7 didn't even have an
installer, so that wouldn't be an issue.  It's not unusual, even for nice
installers, to fail to clean up after beta/pre-release versions.
Comment 141 Olaf van der Spek 2005-04-04 10:44:33 PDT
> It's not unusual, even for nice installers, to fail to clean up after 
beta/pre-release versions.

And that's supposed to justify Mozilla installers doing the same?
Comment 142 Max 2005-04-04 11:10:31 PDT
(In reply to comment #139)

> What about .7, .8, .9?

I think it would be very cool if the installer could clean up previous installs
of these builds.
Comment 143 David G King 2005-04-04 16:06:41 PDT
(In reply to comment #141)
> > It's not unusual, even for nice installers, to fail to clean up after 
> beta/pre-release versions.
> 
> And that's supposed to justify Mozilla installers doing the same?

Justification - maybe not.
Explanation - Yes.

Having tested betas of IE (and other MS products), I know for a fact that
Microsoft don't clean up after their beta versions. If the creater of the OS
(with their inside knowledge of the full API set) can't do it, what hope does
Mozilla have?
Comment 144 Max 2005-04-05 12:54:45 PDT
(In reply to comment #143)
> Having tested betas of IE (and other MS products), I know for a fact that
> Microsoft don't clean up after their beta versions. If the creater of the OS
> (with their inside knowledge of the full API set) can't do it, what hope does
> Mozilla have?

Much hope, since we're better than Microsoft.
Comment 145 Erlendur S Thorsteinsson 2005-04-06 17:29:57 PDT
(In reply to comment #135)
> 
> I agree that seems to be the optimal solution, but that would be a separate
> enhancement bug.

Posted as bug #289370.
Comment 146 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-04-09 22:06:27 PDT
*** Bug 289762 has been marked as a duplicate of this bug. ***
Comment 147 Matthias Versen [:Matti] 2005-04-11 12:31:10 PDT
*** Bug 289939 has been marked as a duplicate of this bug. ***
Comment 148 Emil Heinze 2005-04-12 00:17:47 PDT
I've just updated my FF from 1.0.1 to 1.0.2, thinking that the problem was
solved, but oooh no! Now there are two entries in my add/remove programs list
*again*! How hard can it be? FF is the only program, I can think of which does
this, and I know that the Mozilla guys are cool programmers, so I simply don't
understand why it can be so hard to fix this bug. Is it a lack of resources?
Comment 149 Chris Blore 2005-04-12 00:24:20 PDT
The bug is marked as fixed-aviary1.0.3, meaning that it is not in the current
latest official build, 1.0.2. The next official build is 1.0.3 that will be
released shortly. Please do not comment unless you have read the bug through and
have something extra to add about the fix and whether or not it needs to be
improved in a manner that has not been previously discussed here.
Comment 150 Emil Heinze 2005-04-12 01:12:16 PDT
Okay, my bad. Thought i saw "fixed-aviary1.0.2" some time ago, but that was
obviously wrong. Sorry.
Comment 151 :Gavin Sharp [email: gavin@gavinsharp.com] 2005-04-12 21:31:46 PDT
*** Bug 290119 has been marked as a duplicate of this bug. ***
Comment 152 Matthias Versen [:Matti] 2005-04-16 20:12:15 PDT
*** Bug 290654 has been marked as a duplicate of this bug. ***
Comment 153 Jo Hermans 2005-04-17 11:29:40 PDT
*** Bug 290718 has been marked as a duplicate of this bug. ***
Comment 154 Jo Hermans 2005-04-26 11:29:47 PDT
*** Bug 291955 has been marked as a duplicate of this bug. ***
Comment 155 Joseph Wright 2005-04-27 01:04:12 PDT
*** Bug 292057 has been marked as a duplicate of this bug. ***
Comment 156 Thomas K. (:tom) 2005-04-27 21:24:19 PDT
*** Bug 292161 has been marked as a duplicate of this bug. ***
Comment 157 Mark Dowling 2005-05-17 09:28:37 PDT
If a 1.0.4 is installed over 1.0.x in Windows XP, not all of the registry stuff
is cleaned up, so that if you install the flash player over that (for instance),
it still shows 1.0.x (x<4) as installed.
Comment 158 Worcester12345 2005-05-17 14:37:49 PDT
(In reply to comment #157)
> If a 1.0.4 is installed over 1.0.x in Windows XP, not all of the registry stuff
> is cleaned up, so that if you install the flash player over that (for instance),
> it still shows 1.0.x (x<4) as installed.

Reopen?
Comment 159 Masayuki Nakano [:masayuki] (Mozilla Japan) 2005-05-17 14:46:26 PDT
The problem is bug 294357(firefox & thunderbird) and bug 264386(suite).
Don't reopen this.
Comment 160 Gabriel Chadwick 2005-05-17 14:52:36 PDT
It could be caused by flash not reading good string when trying to verify wich
ff is installed. Already saw this elsewhere. Not related to this bug.
Comment 161 Worcester12345 2005-05-27 12:07:24 PDT
I've found PR's, RC's, .4 through current 1.0.0+ of Mozilla, Firebird, Firefox,
and Thunderbird. Perhaps there should be a Mozilla utility to clear out ALL of
these settings so they can be put in anew by the latest install. It would be
great if that were part of the installer, but a separate program would do.
Comment 162 Dave Townsend [:mossop] 2005-08-22 05:44:47 PDT
*** Bug 305468 has been marked as a duplicate of this bug. ***
Comment 163 u49640 2007-03-11 10:38:09 PDT
Created attachment 258212 [details]
Still a problem

I've just noticed that i still see this bug (see screenshot)

I've installed 2.0.0.1 and later updated to 2.0.0.2. (via auto Update)

--> Uninstall is shown twice in the add/remove dialog

when i select "uninstall" for 2.0.0.1, Windows told me that Firefox 2.0.0.1 is allready removed and asks me to delete it from the list.
Comment 164 Alan Sanderson 2007-03-11 23:53:53 PDT
I've just upgraded manually from 2.0.0.2 to 2.0.0.3 RC1 and didn't notice this problem occurring. My guess is that it is related to auto update.
Comment 165 u49640 2007-04-28 02:58:25 PDT
just had the same problem with 2.0.0.2 -> 2.0.0.3. (I now have 2.0.0.1, 2.0.0.2 and 2.0.0.3 in my Ad/Remove list)

Please re-Open this bug because it is definitley not fixed!
Comment 166 Worcester12345 2007-04-28 19:45:44 PDT
Seconded on reopen request. Seeing it here also.
Comment 167 Henrik Skupin (:whimboo) [away 09/30 - 10/06] 2007-07-23 06:08:54 PDT
We won't reopen this bug. The last comments also talk about auto update while this bug handles the installer. I filed bug 389244 for this issue.
Comment 168 coinman 2012-09-07 18:04:18 PDT
I'd just like to report that the 15.0.1 update today, did not remove the 15.0 version from the installed programs list (Windows 7).
http://i.imgur.com/A04iT.jpg
Comment 169 MarkRH 2012-09-08 12:54:56 PDT
I got the duplicate 15.0 and 15.0.1 entries in Windows 7 Pro 64-bit Programs and Features list as well after I updated using the internal updater through the Help > About window. Went hunting in the registry and I found:

FF 15.0.1 Uninstall information was stored here:
HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox 15.0.1 (x86 en-US)

FF 15.0 Uninstall information was stored here:

HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox 15.0 (x86 en-US)

Wonder if it's related to the Mozilla Maintenance Service thing. Almost like FF 15.0.1 was handled like a User only install. A new bug might need to be created.. looks like this specific one will never be looked at again(?).
Comment 170 Henrik Skupin (:whimboo) [away 09/30 - 10/06] 2012-09-08 13:37:22 PDT
Can one of you please file a new bug on that issue? This bug has been closed ages ago, so you are most likely seeing something new. Thanks.
Comment 171 MarkRH 2012-09-08 13:58:29 PDT
I created a new bug here: https://bugzilla.mozilla.org/show_bug.cgi?id=789743

Note You need to log in before you can comment on or make changes to this bug.